/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using MPLAB� Code Configurator

  @Description:
    This header file provides implementations for pin APIs for all pins selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB� Code Configurator - v2.25.2
        Device            :  PIC16F1619
        Version           :  1.01
    The generated drivers are tested against the following:
        Compiler          :  XC8 v1.34
        MPLAB             :  MPLAB X v2.35 or v3.00
 */

/*
Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
 */

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set D5 aliases
#define D5_TRIS               TRISA1
#define D5_LAT                LATA1
#define D5_PORT               RA1
#define D5_ANS                ANSA1
#define D5_SetHigh()    do { LATA1 = 1; } while(0)
#define D5_SetLow()   do { LATA1 = 0; } while(0)
#define D5_Toggle()   do { LATA1 = ~LATA1; } while(0)
#define D5_GetValue()         RA1
#define D5_SetDigitalInput()    do { TRISA1 = 1; } while(0)
#define D5_SetDigitalOutput()   do { TRISA1 = 0; } while(0)

#define D5_SetAnalogMode()   do { ANSA1 = 1; } while(0)
#define D5_SetDigitalMode()   do { ANSA1 = 0; } while(0)
// get/set D6 aliases
#define D6_TRIS               TRISA2
#define D6_LAT                LATA2
#define D6_PORT               RA2
#define D6_ANS                ANSA2
#define D6_SetHigh()    do { LATA2 = 1; } while(0)
#define D6_SetLow()   do { LATA2 = 0; } while(0)
#define D6_Toggle()   do { LATA2 = ~LATA2; } while(0)
#define D6_GetValue()         RA2
#define D6_SetDigitalInput()    do { TRISA2 = 1; } while(0)
#define D6_SetDigitalOutput()   do { TRISA2 = 0; } while(0)

#define D6_SetAnalogMode()   do { ANSA2 = 1; } while(0)
#define D6_SetDigitalMode()   do { ANSA2 = 0; } while(0)
// get/set RST aliases
#define RST_TRIS               TRISA4
#define RST_LAT                LATA4
#define RST_PORT               RA4
#define RST_ANS                ANSA4
#define RST_SetHigh()    do { LATA4 = 1; } while(0)
#define RST_SetLow()   do { LATA4 = 0; } while(0)
#define RST_Toggle()   do { LATA4 = ~LATA4; } while(0)
#define RST_GetValue()         RA4
#define RST_SetDigitalInput()    do { TRISA4 = 1; } while(0)
#define RST_SetDigitalOutput()   do { TRISA4 = 0; } while(0)

#define RST_SetAnalogMode()   do { ANSA4 = 1; } while(0)
#define RST_SetDigitalMode()   do { ANSA4 = 0; } while(0)
// get/set D4 aliases
#define D4_TRIS               TRISA5
#define D4_LAT                LATA5
#define D4_PORT               RA5
#define D4_SetHigh()    do { LATA5 = 1; } while(0)
#define D4_SetLow()   do { LATA5 = 0; } while(0)
#define D4_Toggle()   do { LATA5 = ~LATA5; } while(0)
#define D4_GetValue()         RA5
#define D4_SetDigitalInput()    do { TRISA5 = 1; } while(0)
#define D4_SetDigitalOutput()   do { TRISA5 = 0; } while(0)

// get/set SDI aliases
#define SDI_TRIS               TRISB4
#define SDI_LAT                LATB4
#define SDI_PORT               RB4
#define SDI_ANS                ANSB4
#define SDI_SetHigh()    do { LATB4 = 1; } while(0)
#define SDI_SetLow()   do { LATB4 = 0; } while(0)
#define SDI_Toggle()   do { LATB4 = ~LATB4; } while(0)
#define SDI_GetValue()         RB4
#define SDI_SetDigitalInput()    do { TRISB4 = 1; } while(0)
#define SDI_SetDigitalOutput()   do { TRISB4 = 0; } while(0)

#define SDI_SetAnalogMode()   do { ANSB4 = 1; } while(0)
#define SDI_SetDigitalMode()   do { ANSB4 = 0; } while(0)
// get/set RX aliases
#define RX_TRIS               TRISB5
#define RX_LAT                LATB5
#define RX_PORT               RB5
#define RX_ANS                ANSB5
#define RX_SetHigh()    do { LATB5 = 1; } while(0)
#define RX_SetLow()   do { LATB5 = 0; } while(0)
#define RX_Toggle()   do { LATB5 = ~LATB5; } while(0)
#define RX_GetValue()         RB5
#define RX_SetDigitalInput()    do { TRISB5 = 1; } while(0)
#define RX_SetDigitalOutput()   do { TRISB5 = 0; } while(0)

#define RX_SetAnalogMode()   do { ANSB5 = 1; } while(0)
#define RX_SetDigitalMode()   do { ANSB5 = 0; } while(0)
// get/set SCK aliases
#define SCK_TRIS               TRISB6
#define SCK_LAT                LATB6
#define SCK_PORT               RB6
#define SCK_WPU                WPUB6
#define SCK_SetHigh()    do { LATB6 = 1; } while(0)
#define SCK_SetLow()   do { LATB6 = 0; } while(0)
#define SCK_Toggle()   do { LATB6 = ~LATB6; } while(0)
#define SCK_GetValue()         RB6
#define SCK_SetDigitalInput()    do { TRISB6 = 1; } while(0)
#define SCK_SetDigitalOutput()   do { TRISB6 = 0; } while(0)

#define SCK_SetPullup()    do { WPUB6 = 1; } while(0)
#define SCK_ResetPullup()   do { WPUB6 = 0; } while(0)
// get/set TX aliases
#define TX_TRIS               TRISB7
#define TX_LAT                LATB7
#define TX_PORT               RB7
#define TX_WPU                WPUB7
#define TX_SetHigh()    do { LATB7 = 1; } while(0)
#define TX_SetLow()   do { LATB7 = 0; } while(0)
#define TX_Toggle()   do { LATB7 = ~LATB7; } while(0)
#define TX_GetValue()         RB7
#define TX_SetDigitalInput()    do { TRISB7 = 1; } while(0)
#define TX_SetDigitalOutput()   do { TRISB7 = 0; } while(0)

#define TX_SetPullup()    do { WPUB7 = 1; } while(0)
#define TX_ResetPullup()   do { WPUB7 = 0; } while(0)
// get/set WKHW aliases
#define WKHW_TRIS               TRISC0
#define WKHW_LAT                LATC0
#define WKHW_PORT               RC0
#define WKHW_ANS                ANSC0
#define WKHW_SetHigh()    do { LATC0 = 1; } while(0)
#define WKHW_SetLow()   do { LATC0 = 0; } while(0)
#define WKHW_Toggle()   do { LATC0 = ~LATC0; } while(0)
#define WKHW_GetValue()         RC0
#define WKHW_SetDigitalInput()    do { TRISC0 = 1; } while(0)
#define WKHW_SetDigitalOutput()   do { TRISC0 = 0; } while(0)

#define WKHW_SetAnalogMode()   do { ANSC0 = 1; } while(0)
#define WKHW_SetDigitalMode()   do { ANSC0 = 0; } while(0)
// get/set WKSW aliases
#define WKSW_TRIS               TRISC1
#define WKSW_LAT                LATC1
#define WKSW_PORT               RC1
#define WKSW_ANS                ANSC1
#define WKSW_SetHigh()    do { LATC1 = 1; } while(0)
#define WKSW_SetLow()   do { LATC1 = 0; } while(0)
#define WKSW_Toggle()   do { LATC1 = ~LATC1; } while(0)
#define WKSW_GetValue()         RC1
#define WKSW_SetDigitalInput()    do { TRISC1 = 1; } while(0)
#define WKSW_SetDigitalOutput()   do { TRISC1 = 0; } while(0)

#define WKSW_SetAnalogMode()   do { ANSC1 = 1; } while(0)
#define WKSW_SetDigitalMode()   do { ANSC1 = 0; } while(0)
// get/set RW aliases
#define RW_TRIS               TRISC2
#define RW_LAT                LATC2
#define RW_PORT               RC2
#define RW_ANS                ANSC2
#define RW_SetHigh()    do { LATC2 = 1; } while(0)
#define RW_SetLow()   do { LATC2 = 0; } while(0)
#define RW_Toggle()   do { LATC2 = ~LATC2; } while(0)
#define RW_GetValue()         RC2
#define RW_SetDigitalInput()    do { TRISC2 = 1; } while(0)
#define RW_SetDigitalOutput()   do { TRISC2 = 0; } while(0)

#define RW_SetAnalogMode()   do { ANSC2 = 1; } while(0)
#define RW_SetDigitalMode()   do { ANSC2 = 0; } while(0)
// get/set S1 aliases
#define S1_TRIS               TRISC4
#define S1_LAT                LATC4
#define S1_PORT               RC4
#define S1_WPU                WPUC4
#define S1_SetHigh()    do { LATC4 = 1; } while(0)
#define S1_SetLow()   do { LATC4 = 0; } while(0)
#define S1_Toggle()   do { LATC4 = ~LATC4; } while(0)
#define S1_GetValue()         RC4
#define S1_SetDigitalInput()    do { TRISC4 = 1; } while(0)
#define S1_SetDigitalOutput()   do { TRISC4 = 0; } while(0)

#define S1_SetPullup()    do { WPUC4 = 1; } while(0)
#define S1_ResetPullup()   do { WPUC4 = 0; } while(0)
// get/set DC aliases
#define DC_TRIS               TRISC5
#define DC_LAT                LATC5
#define DC_PORT               RC5
#define DC_WPU                WPUC5
#define DC_SetHigh()    do { LATC5 = 1; } while(0)
#define DC_SetLow()   do { LATC5 = 0; } while(0)
#define DC_Toggle()   do { LATC5 = ~LATC5; } while(0)
#define DC_GetValue()         RC5
#define DC_SetDigitalInput()    do { TRISC5 = 1; } while(0)
#define DC_SetDigitalOutput()   do { TRISC5 = 0; } while(0)

#define DC_SetPullup()    do { WPUC5 = 1; } while(0)
#define DC_ResetPullup()   do { WPUC5 = 0; } while(0)
// get/set CS aliases
#define CS_TRIS               TRISC6
#define CS_LAT                LATC6
#define CS_PORT               RC6
#define CS_ANS                ANSC6
#define CS_SetHigh()    do { LATC6 = 1; } while(0)
#define CS_SetLow()   do { LATC6 = 0; } while(0)
#define CS_Toggle()   do { LATC6 = ~LATC6; } while(0)
#define CS_GetValue()         RC6
#define CS_SetDigitalInput()    do { TRISC6 = 1; } while(0)
#define CS_SetDigitalOutput()   do { TRISC6 = 0; } while(0)

#define CS_SetAnalogMode()   do { ANSC6 = 1; } while(0)
#define CS_SetDigitalMode()   do { ANSC6 = 0; } while(0)
// get/set SDO aliases
#define SDO_TRIS               TRISC7
#define SDO_LAT                LATC7
#define SDO_PORT               RC7
#define SDO_ANS                ANSC7
#define SDO_SetHigh()    do { LATC7 = 1; } while(0)
#define SDO_SetLow()   do { LATC7 = 0; } while(0)
#define SDO_Toggle()   do { LATC7 = ~LATC7; } while(0)
#define SDO_GetValue()         RC7
#define SDO_SetDigitalInput()    do { TRISC7 = 1; } while(0)
#define SDO_SetDigitalOutput()   do { TRISC7 = 0; } while(0)

#define SDO_SetAnalogMode()   do { ANSC7 = 1; } while(0)
#define SDO_SetDigitalMode()   do { ANSC7 = 0; } while(0)

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    GPIO and peripheral I/O initialization
 * @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize(void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);

#endif // PIN_MANAGER_H
/**
 End of File
 */