#include "mcc_generated_files/mcc.h"
#include "font.h"
#include "oled_c.h"

void OLED_C_command(unsigned char reg_index, unsigned char reg_value){
//Select index addr
    CS_SetLow();
    DC_SetLow();
    //SPI1_Write(reg_index);
    SPI_Exchange8bit(reg_index);
    CS_SetHigh();
//Write data to reg
    CS_SetLow();
    DC_SetHigh();
    //SPI1_Write(reg_value);
    SPI_Exchange8bit(reg_value);
    CS_SetHigh();
}

void OLED_C_data(unsigned char data_value){
    CS_SetLow();
    
    DC_SetHigh();
    //SPI1_Write(data_value);
    SPI_Exchange8bit(data_value);
    CS_SetHigh();
}

void OLED_C_Init(){
    RST_SetLow();
    delay_ms(50);
    RST_SetHigh();
    delay_ms(50);
    /*  Soft reset */
    OLED_C_command(SEPS114A_SOFT_RESET,0x00);      
    /* Standby ON/OFF*/
    OLED_C_command(SEPS114A_STANDBY_ON_OFF,0x01);          // Standby on
    delay_ms(25);                                           // Wait for 5ms (1ms Delay Minimum)
    OLED_C_command(SEPS114A_STANDBY_ON_OFF,0x00);          // Standby off
    delay_ms(25);                                           // 1ms Delay Minimum (1ms Delay Minimum)
    /* Display OFF */
    OLED_C_command(SEPS114A_DISPLAY_ON_OFF,0x00);
    /* Set Oscillator operation */
    OLED_C_command(SEPS114A_ANALOG_CONTROL,0x00);          // using external resistor and internal OSC
    /* Set frame rate */
    OLED_C_command(SEPS114A_OSC_ADJUST,0x03);              // frame rate : 95Hz
    /* Set active display area of panel */
    OLED_C_command(SEPS114A_DISPLAY_X1,0x00);
    OLED_C_command(SEPS114A_DISPLAY_X2,0x5F);
    OLED_C_command(SEPS114A_DISPLAY_Y1,0x00);
    OLED_C_command(SEPS114A_DISPLAY_Y2,0x5F);
    /* Select the RGB data format and set the initial state of RGB interface port */
    OLED_C_command(SEPS114A_RGB_IF,0x00);                 // RGB 8bit interface
    /* Set RGB polarity */
    OLED_C_command(SEPS114A_RGB_POL,0x00);
    /* Set display mode control */
    OLED_C_command(SEPS114A_DISPLAY_MODE_CONTROL,0x80);   // SWAP:BGR, Reduce current : Normal, DC[1:0] : Normal
    /* Set MCU Interface */
    OLED_C_command(SEPS114A_CPU_IF,0x00);                 // MPU External interface mode, 8bits
    /* Set Memory Read/Write mode */
    OLED_C_command(SEPS114A_MEMORY_WRITE_READ,0x00);
    /* Set row scan direction */
    OLED_C_command(SEPS114A_ROW_SCAN_DIRECTION,0x00);     // Column : 0 --> Max, Row : 0 --> Max
    /* Set row scan mode */
    OLED_C_command(SEPS114A_ROW_SCAN_MODE,0x00);          // Alternate scan mode
    /* Set column current */
    OLED_C_command(SEPS114A_COLUMN_CURRENT_R,0x6E);
    OLED_C_command(SEPS114A_COLUMN_CURRENT_G,0x4F);
    OLED_C_command(SEPS114A_COLUMN_CURRENT_B,0x77);
    /* Set row overlap */
    OLED_C_command(SEPS114A_ROW_OVERLAP,0x00);            // Band gap only
    /* Set discharge time */
    OLED_C_command(SEPS114A_DISCHARGE_TIME,0x01);         // Discharge time : normal discharge
    /* Set peak pulse delay */
    OLED_C_command(SEPS114A_PEAK_PULSE_DELAY,0x00);
    /* Set peak pulse width */
    OLED_C_command(SEPS114A_PEAK_PULSE_WIDTH_R,0x02);
    OLED_C_command(SEPS114A_PEAK_PULSE_WIDTH_G,0x02);
    OLED_C_command(SEPS114A_PEAK_PULSE_WIDTH_B,0x02);
    /* Set precharge current */
    OLED_C_command(SEPS114A_PRECHARGE_CURRENT_R,0x14);
    OLED_C_command(SEPS114A_PRECHARGE_CURRENT_G,0x50);
    OLED_C_command(SEPS114A_PRECHARGE_CURRENT_B,0x19);
    /* Set row scan on/off  */
    OLED_C_command(SEPS114A_ROW_SCAN_ON_OFF,0x00);        // Normal row scan
    /* Set scan off level */
    OLED_C_command(SEPS114A_SCAN_OFF_LEVEL,0x04);         // VCC_C*0.75
    /* Set memory access point */
    OLED_C_command(SEPS114A_DISPLAYSTART_X,0x00);
    OLED_C_command(SEPS114A_DISPLAYSTART_Y,0x00);
    /* Display ON */
    OLED_C_command(SEPS114A_DISPLAY_ON_OFF,0x01);
}

void DDRAM_access(){
    CS_SetLow();
    DC_SetLow();
    //SPI1_Write(0x08);
    SPI_Exchange8bit(0x08);
    CS_SetHigh();
}

//Set memory area(address) to write a display data
void OLED_C_MemorySize(char X1, char X2, char Y1, char Y2){
    OLED_C_command(SEPS114A_MEM_X1,X1);
    OLED_C_command(SEPS114A_MEM_X2,X2);
    OLED_C_command(SEPS114A_MEM_Y1,Y1);
    OLED_C_command(SEPS114A_MEM_Y2,Y2);
}

//Select color
void OLED_C_Color(char colorMSB, char colorLSB ){
    OLED_C_data(colorMSB);
    OLED_C_data(colorLSB);
}

void OLED_C_Background(){
    OLED_C_command(0x1D,0x02);                //Set Memory Read/Write mode
    
    OLED_C_MemorySize(0x00,0x5F,0x00,0x5F);   //Full screen
    DDRAM_access();
    for(unsigned lj=0;lj<9216;lj++){
        OLED_C_Color(0x00,0x00);
    }
}

/*
void OLED_C_print_char(unsigned char x_pos, unsigned char y_pos, unsigned char ch){
    unsigned char chr = 0x00;
    unsigned char s = 0x00;
    if ((ch < 32) || (ch > 127)){
        ch = '?';
    }
    chr = (ch - 32);
    OLED_C_MemorySize(x_pos,x_pos + 7,y_pos, y_pos + 5);
    DDRAM_access();
    for(int cx = 0; cx < 6; cx++){
        unsigned char c = Font_Right[chr][6 - cx];
        for(int cy = 0; cy < 8; cy ++){
            if(((c >> cy) & 0x01) == 0x01){
                OLED_C_Color(0xFF,0xFF);
            } else {
                OLED_C_Color(0x00,0x00);
            }
        }
    }
}
*/

void OLED_C_print_char(unsigned char x_pos, unsigned char y_pos, unsigned char ch){
    unsigned char chr = 0x00;
    unsigned char s = 0x00;
    if ((ch < 32) || (ch > 127)){
        ch = '?';
    }
    chr = (ch - 32);
    OLED_C_MemorySize(x_pos, x_pos + 4, y_pos, y_pos + 4);
    DDRAM_access();
    for(int cx = 0; cx < 5; cx++){
        unsigned char c = Tiny_Font[chr][4 - cx];
        for(int cy = 0; cy < 5; cy ++){
            if(((c >> cy) & 0x01) == 0x01){
                OLED_C_Color(0xFF,0xFF);
            } else {
                OLED_C_Color(0x00,0x00);
            }
        }
    }
}


void OLED_C_print(unsigned char x_pos, unsigned char y_pos, unsigned char ch[]){
    for(int cc = 0; cc < length(ch); cc++){
        OLED_C_print_char(x_pos, y_pos + (cc * 5), ch[cc]);
    }
}

int length(const unsigned char array[]) {
  int count = 0;
  while(array[count]) count++;
  return count;
}

void delay_ms(int msec){
    TMR1_StartTimer();
    for (int x = 0; x < msec; x++){
        while(!TMR1IF);
        TMR1_Reload();
        TMR1IF = 0;
    }
    //TMR1_StopTimer();
}