#include "mcc_generated_files/mcc.h"
#include "main.h"
#include "oled_c.h"
#include "rn4020.h"

void BLE_Reboot(){
    EUSART_Write('R');
    EUSART_Write(',');
    EUSART_Write('1');
    EUSART_Write(13);
    EUSART_Write(10); 
}

void BLE_PartialReset(){
    EUSART_Write('S');
    EUSART_Write('F');
    EUSART_Write(',');
    EUSART_Write('1');
    EUSART_Write(13);
    EUSART_Write(10);
}

void BLE_FullReset(){
    EUSART_Write('S');
    EUSART_Write('F');
    EUSART_Write(',');
    EUSART_Write('2');
    EUSART_Write(13);
    EUSART_Write(10);
}

void BLE_SetSpeed(unsigned baudrate){
}

void BLE_SetService(unsigned char service[]){
    EUSART_Write('S');
    EUSART_Write('S');
    EUSART_Write(',');
    int count = 0;
    while(service[count]){
        if (service[count]>0){
            EUSART_Write(service[count]);
        }
        count++;
    }
    EUSART_Write(13);
    EUSART_Write(10);
}

void BLE_SetRole(unsigned char role[]){
    EUSART_Write('S');
    EUSART_Write('R');
    EUSART_Write(',');
    int count = 0;
    while(role[count]){
        if (role[count]>0){
            EUSART_Write(role[count]);
        }
        count++;
    }
    EUSART_Write(13);
    EUSART_Write(10);
}

void BLE_SetBroadcaster(unsigned char advert[]){
    EUSART_Write('N');
    EUSART_Write(',');
    int count = 0;
    while(advert[count]){
        if (advert[count]>0){
            EUSART_Write(advert[count]);
        }
        count++;
    }
    EUSART_Write(13);
    EUSART_Write(10);
}

void BLE_StartScan(){
    EUSART_Write('F');
    EUSART_Write(13);
    EUSART_Write(10);
}

void BLE_StartBroadcast(){
    EUSART_Write('A');
    EUSART_Write(13);
    EUSART_Write(10);
}

void BLE_GetVersion(){
    EUSART_Write('V');
    EUSART_Write(13);
    EUSART_Write(10);
}

void BLE_GetInfo(){
    EUSART_Write('D');
    EUSART_Write(13);
    EUSART_Write(10);
}

void BLE_ToggleEcho(){
    EUSART_Write('+');
    EUSART_Write(13);
    EUSART_Write(10);
}

void BLE_SetDeviceName(unsigned char devicename[]){
    EUSART_Write('S');
    EUSART_Write('-');
    EUSART_Write(',');
    int count = 0;
    while(devicename[count]){
        if (devicename[count]>0){
            EUSART_Write(devicename[count]);
        }
        count++;
    }
    EUSART_Write(13);
    EUSART_Write(10);
}

void BLE_SendBatteryValue(unsigned char blev[]){
    EUSART_Write('S');
    EUSART_Write('U');
    EUSART_Write('W');
    EUSART_Write(',');
    EUSART_Write('2');
    EUSART_Write('A');
    EUSART_Write('1');
    EUSART_Write('9');
    EUSART_Write(',');
    int count = 0;
    while(blev[count]){
        if (blev[count]>0){
            EUSART_Write(blev[count]);
        }
        count++;
    }
    EUSART_Write(13);
    EUSART_Write(10);
}

void BLE_GetClientServices(){
    EUSART_Write('L');
    EUSART_Write('C');
    EUSART_Write(13);
    EUSART_Write(10);
}

void BLE_GetServerServices(){
    EUSART_Write('L');
    EUSART_Write('S');
    EUSART_Write(13);
    EUSART_Write(10);
}

void BLE_Command(unsigned char cmd[]){
    int count = 0;
    while(cmd[count]){
        if (cmd[count]>0){
            EUSART_Write(cmd[count]);
        }
        count++;
    }
    EUSART_Write(13);
    EUSART_Write(10);
}

